 (function(global) {
    var baseURL;

    if(window.cordova) {
        global.production_settings = {
            apiURL: "http://yesnogame.thebigchallenge.com/api/",
            clientURL: "http://yesnogame.thebigchallenge.com",
            inviteURL: "yesnogame.thebigchallenge.com",
            facebookAppId: '488377974617650',
            senderID: "417101270954"
        }
    } else {
        global.production_settings = {
            apiURL: "//yesnogame.thebigchallenge.com/api/",
            clientURL: "//yesnogame.thebigchallenge.com",
            inviteURL: "yesnogame.thebigchallenge.com",
            facebookAppId: '488377974617650',
            senderID: "417101270954"
        }
    }

    global.development_settings = {
        apiURL: "http://quizj.ag.wap3.com.ua/api/",
        clientURL: "http://quizj.ag.wap3.com.ua/client",
        inviteURL: "quizj.ag.wap3.com.ua/client/index.html",
        facebookAppId: '539578166164297',
        senderID: "417101270954"
    }

    global.jepilote_settings = {
        apiURL: "//yesnogame.jepilote.agilonaute.net/api/",
        clientURL: "//yesnogame.jepilote.agilonaute.net",
        inviteURL: "yesnogame.thebigchallenge.com",
        facebookAppId: '488377974617650',
        senderID: "417101270954"
    }

    global.yesnogame_staging_settings = {
        apiURL: "//yesnogame.test.thebigchallenge.com/api/",
        clientURL: "//yesnogame.test.thebigchallenge.com/client",
        inviteURL: "//yesnogame.test.thebigchallenge.com/client/index.html",
        facebookAppId: '830792650376179',
        senderID: "417101270954"
    }

    var settings = {
        achievementPath: "/achievements/category_unlocked_" + appLanguage + ".php",
        login: "quiz",
        password: "ololo",
        imageSize: 300
    }

    for(var opt in global[global.environment + "_settings"]){
        if(global[global.environment + "_settings"].hasOwnProperty(opt)) {
            settings[opt] = global[global.environment + "_settings"][opt];
        }
    }

    settings.achievementURL = "http://yesnogame.thebigchallenge.com" + settings.achievementPath;

    function addUrl(key, url, method){
        settings[key] = {
            url: settings.apiURL + url,
            method: method || "POST"
        }
    }

    addUrl("auth", "auth/");

    // Users
    addUrl("register", "call/user/register/email");
    addUrl("signin", "call/user/login/email");
    addUrl("signinWithSSO", "call/user/login/sso");

    addUrl("registerWithFacebook", "call/user/register/facebook");
    addUrl("signinWithFacebook", "call/user/login/facebook");

    addUrl("linkFacebook", "call/user/{userID}/facebook", "PUT");
    addUrl("putFacebookFriends", "call/user/{userID}/friends", "PUT");
    addUrl("updateProfile", "call/user/{userID}/profile", "PUT");
    addUrl("loadScore", "call/user/{userID}/score", "GET");
    addUrl("loadRanking", "call/user/{userID}/ranking/{limit}", "GET");

    addUrl("requestRestorePassword", "call/user/password/forgot");
    addUrl("restorePassword", "call/user/password/forgot/check");

    addUrl("invitedUserCome", "call/user/invite/code");
    addUrl("inviteFacebookFriends", "call/user/{userID}/invite/facebook");
    addUrl("inviteFriendsByEmail", "call/user/{userID}/invite/email");
    addUrl("postFeedback", "call/user/{userID}/feedback");
    addUrl("registerUserDevice", "call/user/{userID}/device", "PUT");

    // Ranking
    addUrl("categoryRanking", "call/user/{userID}/rank/category/{limit}", "GET");
    addUrl("last1000Ranking", "call/user/{userID}/rank/last1000/games/{limit}", "GET");
    addUrl("monthRanking", "call/user/{userID}/rank/month/{month}/{limit}", "GET");

    // Data sync
    addUrl("sync", "call/data/version/{version}", "GET");
    addUrl("checkSync", "call/data/version/{version}/check", "GET");

    addUrl("getCategories", "call/data/categories/{version}", "GET");
    addUrl("getCategoryQuestions", "call/data/{categoryId}/{version}/questions", "GET");
    addUrl("syncCategoryMedia", "call/data/{categoryId}/{version}/media/{width}/{height}/{audioType}");

    addUrl("syncFiles", "call/data/version/{version}/files/{width}/{height}/{audioType}", "GET");

    // Games
    addUrl("saveGame", "call/game/save");
    addUrl("unlockCategory", "call/category/unlock");
    addUrl("specialCategoryBackground", "media_prop/category/categorybg/{width}/{height}/{categoryID}.png");

    // Review
    addUrl("loadReviewQuestions", "call/question/{userID}/review", "GET");
    addUrl("saveReviewQuestion", "call/question/{userID}/review", "POST");
    addUrl("deleteReviewQuestions", "call/question/{userID}/review", "DELETE");
    addUrl("syncReviewMedia", "call/question/{userID}/review/data/{width}/{height}/{audioType}")

    // Schools
    addUrl("countries", "call/school/countries", "GET");
    addUrl("regions", "call/school/country/{countryId}/regions", "GET");
    addUrl("cities", "call/school/region/{regionId}/cities", "GET");
    addUrl("schools", "call/school/region/{regionId}/city/{cityId}/schools", "GET");
    addUrl("locationBySchoolId", "call/school/{schoolId}", "GET");
    addUrl("countriesWithSchools", "call/user/ranking/countries", "GET");

    var skipLoading = ["sync", "checkSync", "syncFiles", "getCategories", "getCategoryQuestions", "syncCategoryMedia", "saveReviewQuestion"];

    var xhrPool = [];
    $(document).ajaxSend(function(e, jqXHR, options){
        xhrPool.push(jqXHR);
    });

    $(document).ajaxComplete(function(e, jqXHR, options) {
        xhrPool = $.grep(xhrPool, function(x){return x!=jqXHR});
    });

    function QuizAPI(){
        this.retryCount = 0;
    }

    QuizAPI.prototype = {
        auth: function(callback){
            var that=this,
                appPlatform = (window.cordova? cordova.platformId : "web"),
                appVersion = (window.cordova? window.AppVersion : "1.0");

            $.ajax({
                type: "POST",
                url: settings.auth.url,
                crossDomain: true,
                timeout: 13000,
                data: JSON.stringify({
                    login: settings.login,
                    password: settings.password,
                    lang: window.appLanguage,
                    app: appPlatform,
                    appVersion: appVersion
                }),
                dataType: "JSON",
            }).done(function(data) {
                if(data.code == 200) {
                    that.token = data.token;
                    callback && callback();
                }
            }).fail(function(XMLHttpRequest, textStatus, errorThrow){
                app.forceOffline = true;
                app.goOffline();
                app.startOffline();

                global.loading.stop();

                return;
            });
        },
        getURL: function(name, data){
            var url = settings[name].url;
            return url.replace(/\{([^{}]*)\}/g, function($0, $1){
                var replacement = data[$1].toString();
                delete data[$1];
                return replacement;
            });
        },
        callURL: function(name, data, callback, failCallback){
            var url = settings[name].url,
                method = settings[name].method,
                that=this,
                name = name,
                data = data,
                callback = callback,
                failCallback = failCallback;

            failCallback = failCallback || function(){ console.log(arguments) }

            url = url.replace(/\{([^{}]*)\}/g, function($0, $1){
                var replacement = data[$1].toString();
                delete data[$1];
                return replacement;
            });

            if(skipLoading.indexOf(name) === -1) {
                global.loading.start();
            }

            var makeRequest = function(){
                var request, requestData = {
                    type: method,
                    url: url,
                    data: JSON.stringify(data),
                    crossDomain: true,
                    cache: false,
                    beforeSend: function (request){
                        request.setRequestHeader("x-quiz-token", that.token);
                    },
                    dataType: "JSON"
                }

                if(skipLoading.indexOf(name) === -1) {
                    requestData.timeout = 13000;
                }

                $.ajax(requestData).done(function(result){
                    if(skipLoading.indexOf(name) === -1) {
                        global.loading.stop();
                    }

                    that.retryCount = 0;
                    callback && callback(result);

                }).fail(function(XMLHttpRequest, textStatus, errorThrow){
                    if(textStatus==="timeout") {
                        app.goOffline();
                        global.loading.stop();

                        return;
                    }

                    if(skipLoading.indexOf(name) === -1) {
                        global.loading.stop();
                    }

                    if(XMLHttpRequest.status === 500) {
                        askForToken();
                    } else {
                        that.retryCount = 0;
                        failCallback(XMLHttpRequest, textStatus, errorThrow);
                    }
                });
            }

            var askForToken = function(){
                if(that.retryCount < 3){
                    that.retryCount++;
                    that.auth(function(){
                        makeRequest();
                    });
                } else {
                    console.log("YesNo Game is currently unavailable, please try later.")
                }
            }

            if(this.token) {
                makeRequest();
            } else {
                askForToken();
            }
        },
        stopAllRequests: function(){
            $.each(xhrPool, function(idx, jqXHR) {
              jqXHR.abort();
            });
            xhrPool = [];
        }
    }

    global.settings = settings;
    global.quizAPI = new QuizAPI();
})(window);