(function(global){

    function AppViews(){}

    AppViews.prototype = {
        renderLogo: function(isBig){
            this.logo = dom(".logo-wrapper", [
                dom(".arrow.left.back-button"),
                dom(".logo")
            ]);


            this.logo.addEventListener(('ontouchstart' in window)?"touchend":"click", this.goBack.bind(this));

            if(isBig) {
                this.logo.addClass("big");
            } else {
                this.logo.removeClass("big");
            }

            return this.logo;
        },
        renderNoCompatiblePage: function(){
            var that=this;
            app.clearBody();

            var page = dom(".start-page.page.blue-page", [
                dom("header", [
                    dom(".logo")
                ]),
                dom(".content", [
                    dom(".yes-no-game.sign-painter", "yes no game"),
                    dom(".message", _("Sorry, you need a more recent version of your") + "<br>" + _(" navigator to play this game")),
                ])
            ]);

            this.appBody.appendChild(page);
        },
        renderBluePage: function(){
            var app=this;
            app.clearBody();

            var page = dom(".start-page.page.blue-page", [
                dom(".content", [ dom(".logo") ])
            ]);

            this.appBody.appendChild(page);
        },
        renderConnectingPage: function(){
            var that=this;
            app.clearBody();

            var page = dom(".start-page.page.page-without-back-button", [
                dom("header", [
                    this.renderLogo(true),
                    dom(".the-first-contest-wrapper", [
                        dom(".the-first-contest")
                    ])
                ]),
                dom(".yes-no-game.sign-painter", "yes no game"),
                dom(".message-title", _("Oh no!")),
                dom(".message", _("We can't connect to Yes No Game")),
                dom("div.connecting-image", [
                    dom("img", {src: "design/connecting.gif"}),
                ])
            ]);

            this.appBody.appendChild(page);
            app.hideCordovaSplashScreen();
        },
        renderSyncPage: function(withAnimation){
            var that=this;
            app.clearBody();

            var page = dom(".start-page.page.page-without-back-button", [
                dom("header", [
                    this.renderLogo(true),
                    dom(".the-first-contest-wrapper", [
                        dom(".the-first-contest")
                    ])
                ]),
                dom(".content", [
                    dom(".yes-no-game.sign-painter", "yes no game"),
                    dom(".message", [
                        this.percentageLoader = dom("span.percentage-loader")
                    ])
                ])
            ]);

            if(withAnimation) {
                page.addClass("start-animation");
            }

            app.loader = $(this.percentageLoader).percentageLoader({
                width: 180,
                height: 180,
                progress : 0,
                value : '100%'
            });

            this.appBody.appendChild(page);

            app.hideCordovaSplashScreen();
        },
        renderMenuPage: function(){
            app.addPage(function(){
                app.renderMenuPage();
            });

            app.clearBody();

            var page = dom(".page.menu-page.page-without-back-button", {}, [
                dom("header", [
                    this.renderLogo(),
                    dom(".the-first-contest-wrapper", [
                        dom(".the-first-contest")
                    ]),
                    dom(".yes-no-game.sign-painter", "yes no game")
                ]),
                this.contentElement = dom(".content", [
                    this.playButton = dom(".button.play-button", _("Play")),
                    this.scoreButton = dom(".button.score-button", _("Score")),
                ]),
                this.reviewButton = dom(".review-link")
            ]);

            if(app.isReviewAvailable()) {
                this.reviewButton.addClass("active");
            } else {
                this.reviewButton.removeClass("active")
            }

            if(this.isAnonymousUser()){
                this.createProfileButton = dom(".button.profile-button", _("Create profile"));
                this.contentElement.appendChild(this.createProfileButton);
                this.createProfileButton.addEventListener("click", function(){
                    app.user.renderJoinPage();
                });

            } else {
                this.buttons = dom("div", [
                    this.profileButton = dom(".button.profile-button", _("My profile")),
                    this.inviteButton = dom(".button.invite-button", _("Invite friends")),
                    this.feedbackButton = dom(".button.feedback-button", _("Report a problem"))
                ])

                this.contentElement.appendChild(this.buttons);

                this.profileButton.addEventListener("click", function(){
                    app.user.renderProfilePage();
                });

                this.inviteButton.addEventListener("click", function(){
                    if(app.user.isFacebookUser()) {
                        if(window.cordova && !app.signedInWithFacebook) {
                            FB.login(['email', 'user_birthday', 'user_friends'], function(){
                                app.signedInWithFacebook = true;
                                app.user.inviteFacebookFriends();
                            });
                        } else {
                            app.user.inviteFacebookFriends();
                        }
                    } else {
                        app.user.renderInviteByEmailPage();
                    }
                });

                if(!app.onLine) {
                    this.inviteButton.addClass("hidden");
                }

                this.feedbackButton.addEventListener("click", app.user.renderFeedbackPage.bind(app.user))
            }

            this.appBody.appendChild(page);

            if(!app.doNotTrackHistory) {
                window.history.pushState({
                    page: "renderMenuPage"
                }, "Yes No Game");
            } else {
                app.doNotTrackHistory = false;
            }

            this.playButton.addEventListener("click", this.showCategoriesPage.bind(this));
            this.scoreButton.addEventListener("click", this.showScorePage.bind(this));
            this.reviewButton.addEventListener("click", this.renderReviewPage.bind(this));

            app.hideCordovaSplashScreen();
        },
        renderCategoriesPage: function(e){
            if(!app.categoriesPageWasRendered) {
                app.addPage(function(){
                    app.renderCategoriesPage(e);
                });
                app.categoriesPageWasRendered = true;
            }

            app.clearBody();

            var unlockedCategories = [],
                lockedCategories = [],
                categoriesList,
                that = this,
                unlockMode = false,
                useFlagTopOffset;

            this.getUnlockedCategories().forEach(function(category){
                var element = dom(".category", category.name);

                if(category.name.length > 13) {
                    element.addClass("long-name");
                }

                element.addEventListener("click", function(){
                    if(app.categorySynchronizationRequired(category)){
                        if(app.onLine) {
                            app.syncAndStartGame(category);
                        } else {
                            loading.start();
                            app.checkOnline(false,
                                function(){
                                    ;
                                    app.syncAndStartGame(category);
                                },
                                function(){
                                    loading.stop();
                                    dialog("Oh no!", "We can't connect to Yes No Game", [{
                                        value: "OK"
                                    }]);
                                }
                            )
                        }
                    } else if(app.categorySynchronizationAvailable(category)) {
                        dialog(_("Update available"), _("Do you want to update now?"), [{
                            value: _("Yes"),
                            callback: function(){
                                app.syncAndStartGame(category);
                            }
                        }, {
                            value: _("Skip"),
                            callback: function(){
                                app.startGame(category);
                            }
                        }]);
                    } else {
                        app.startGame(category);
                    }

                });

                unlockedCategories.push(element);
                if(category.isSound) {
                    element.appendChild(dom(".category-with-sound.fa.fa-volume-up"));
                }

                if(app.notPassedCategories.indexOf(+category.categoryID) !== -1) {
                    element.appendChild(dom(".corner"));
                }
            });

            this.useFlagsToUnlockCategory = dom(".use-flags-to-unlock.fixedsticky", [
                dom("span", this.user.getFlags()),
                dom("span.flag"),
                dom("span", _("Click to unlock with flags"))
            ]);

            this.getLockedCategories().forEach(function(category, index){
                var element = dom(".category.closed", category.name, [
                    dom(".fa.fa-lock")
                ]);

                if(index === 0) {
                    var tryToUnlock = function(){
                        if(unlockMode){
                            if(category.useFlagsToAvailable > that.user.getFlags()) {
                                dialog(_("You don't have enough flags"),
                                    "<span class='left'>"
                                        + _("To get flags:") + "<br>" +
                                        _(" - Register with <span class='fa fa-facebook-square'></span> = 50 flags") + "<br>" +
                                        _(" - Invite a friend on <span class='fa fa-facebook-square'></span> = 5 flags") + "<br>" +
                                        _(" - Play 1 game = 1 flag") + "<br>" +
                                        _(" - Play 3 times in 1 day = 1 flag") + "<br>" +
                                        _(" - Win a Bonus star <span class='fa fa-star'></span> = 2 flags")
                                    + "</span>",

                                    [{ value: "OK" }]
                                );

                            } else if(app.onLine) {
                                dialog(_("Unlock category"), _("Do you want to use ") + category.useFlagsToAvailable + _(" flags to unlock this category?"), [{
                                        value: _("Confirm"),
                                        callback: function(){
                                            quizAPI.callURL("unlockCategory", {
                                                userId: app.getUserID(),
                                                categoryId: category.categoryID
                                            }, function(result){
                                                app.showCategoriesPage();
                                            })
                                        }
                                    }, {
                                        value: _("Cancel")
                                    }]
                                );
                            } else {
                                dialog(_("You are offline"), _("You must be online to unlock a category with flags"), [{ value: "OK" }])
                            }
                        } else {
                            dialog(_("This category is locked"), _("This category is still locked. Choose a dark blue category at the top of the page."), [{ value: "OK" }])

                        }
                    };

                    unlockButton = dom(".flags-to-unlock", [
                        dom("span", category.useFlagsToAvailable),
                        dom("span.flag")
                    ]);

                    element.appendChild(unlockButton);

                    element.addEventListener("click", tryToUnlock);
                } else {
                    element.addEventListener("click", function(){
                        if(!unlockMode) {
                            dialog(_("This category is locked"), _("This category is still locked. Choose a dark blue category at the top of the page."), [{ value: "OK" }]);
                        }
                    });
                }


                if(category.isSound) {
                    element.appendChild(dom(".category-with-sound.fa.fa-volume-up"));
                }

                if(category.name.length > 13) {
                    element.addClass("long-name");
                }

                lockedCategories.push(element)
            });

            if(lockedCategories.length > 0) {
                categoriesList = [
                    dom(".unlocked-categories", unlockedCategories),
                    this.useFlagsToUnlockCategory,
                    this.lockedCategoriesWrapper = dom(".locked-categories", lockedCategories)
                ]
            } else {
                categoriesList = [ dom(".unlocked-categories", unlockedCategories) ];
            }

            var page, wrapper;

            var page = dom(".page.categories-page", {}, [
                dom("header", [
                    this.renderLogo(),
                    dom(".the-first-contest")
                ]),
                this.categoriesContent = dom(".content.categories-list", [
                    wrapper = dom(".categories-list-wrapper", categoriesList)
                ]),
                this.reviewButton = dom(".review-link")
            ]);

            if(app.isReviewAvailable()) {
                this.reviewButton.addClass("active");
            } else {
                this.reviewButton.removeClass("active")
            }

            wrapper.style.minHeight = 2.5 * (unlockedCategories.length + lockedCategories.length + 1) + "em";

            this.useFlagsToUnlockCategory.addEventListener("click", function(){
                if(that.categoriesContent.hasClass("unlock-mode")) {
                    unlockMode = false;
                    that.categoriesContent.removeClass("unlock-mode");
                } else {
                    if(!("falgsDialogShowed" in localStorage)) {
                        dialog(
                            _("Flags"),
                            "<span class='left'>" + _("The more you play, the more you win flags to unlock new categories.If you score the same number of points as the category goal, you unlock the next category.") + "</span>",
                            [{
                                value: "OK",
                                callback: function(){
                                    localStorage.falgsDialogShowed = true;
                                }
                            }]
                        );
                    }
                    unlockMode = true;
                    that.categoriesContent.addClass("unlock-mode");
                }
            });

            this.appBody.appendChild(page);

            if(!app.doNotTrackHistory) {
                window.history.pushState({
                    page: "renderCategoriesPage"
                }, "Yes No Game");
            } else {
                app.doNotTrackHistory = false;
            }

            $(this.useFlagsToUnlockCategory).fixedsticky();

            this.reviewButton.addEventListener("click", this.renderReviewPage.bind(this));
        }
    }

    window.AppViews = AppViews;
})(window);