(function(global){
    function Dialog(header, message, buttons){
        this.header = header;
        if(typeof message == 'string' || message instanceof String) {
            this.messageElement = dom(".message", message);
        } else {
            this.messageElement = dom(".message", [message])
        }

        this.buttons = buttons;
        this.render();
        this.show();
    }

    Dialog.prototype = {
        render: function(){
            var that=this;
            this.element = dom(".dialog-wrapper", [
                dom(".dialog", [
                    dom("header", this.header),
                    this.messageElement,
                    dom(".buttons", this.buttons.map(
                        function(data){
                            var button = dom(".button", data.value);

                            data.callback && button.addEventListener("click", data.callback);
                            button.addEventListener("click", that.hide.bind(that));
                            return button;
                        })
                    )
                ])
            ])

            return this.element;
        },
        show: function(){
            app.appBody.appendChild(this.element);
            this.element.addClass("active");
        },
        hide: function(){
            this.element.parentNode && this.element.parentNode.removeChild(this.element);
        }
    }

    function dialog(header, message, buttons){
        return new Dialog(header, message, buttons);
    }

    global.dialog = dialog;
    global.Dialog = Dialog;

})(window);