(function(global){
    var inited = false;

    function resizeFontSize(){
        var fontSize = Math.max(14, Math.min(window.innerWidth, window.innerHeight*0.8) * 0.05);
        document.body.style.fontSize = (fontSize||14) + "px";
    };

    function onDeviceReady(){

        if(("FixedSticky" in window) && FixedSticky.tests.sticky) {
            document.body.addClass("sticky-supported");
        }

        if(window.cordova) {
            window.FB = facebookConnectPlugin;
            window.pushNotification = window.plugins.pushNotification;

            cordova.exec(function(version){
                window.AppVersion = version;
            }, function(){ console.log(arguments) }, "AppVersion", "getVersionNumber", []);
        }

        if(inited) return;

        resizeFontSize();

        setTimeout(function(){
            resizeFontSize();
        }, 500);

        global.app = new App();
        if(app.isCompatible()) {
            db.loadAll(app.start.bind(app));

            applicationCache.addEventListener('updateready', function(){
                if (window.applicationCache.status == window.applicationCache.UPDATEREADY) {
                    window.location.reload();
                }
            }, false);
        }

        if(app.isIE()){
            document.documentElement.setAttribute('data-useragent',  navigator.userAgent);
        }
    };

    function forceRedraw(){
        var element = document.getElementById("appBody");
        var disp = element.style.display;
        element.style.display = 'none';
        var trick = element.offsetHeight;
        element.style.display = disp;
    }

    window.addEventListener('load', onDeviceReady ,false);
    window.addEventListener('deviceready', onDeviceReady ,false);

    window.addEventListener('resize', resizeFontSize);
    window.addEventListener('orientationchange', resizeFontSize);
    window.addEventListener('orientationchange', forceRedraw);

})(window);