(function(global){
    'use strict';
    var availableLanguages = ["de", "fr", "es", "uk", "pl", "at", "se"],
        appLanguage = null,
        params = {}, navLanguage, messages;

    location.search.replace("?", "").split("&").forEach(function(param){
        var a = param.split("=");
        params[a[0]] = a[1];
    });

    navLanguage = params.lang||navigator.language||navigator.userLanguage;

    messages = {
        // Synchronization
        "Oh no!": {
        },
        "We can't connect to the Yes No Game": {
        },
        "App data syncing": {
        },
        "Sorry, you need a more recent version of your": {
        },
        "navigator to play this game": {
        },
        "Your connection is not very good": {
        },
        "Do you want to update now?": {
        },
        "Wait": {
        },

        // Main menu
        "Play": {
        },
        "Score": {
        },
        "Create profile": {
        },
        "My profile": {
        },
        "Invite friends": {
        },
        "Privacy policy": {
        },

        // Dialogs
        "Don't display again": {
            "de": "Nicht mehr anzeigen",
            "at": "Nicht mehr anzeigen",
            "fr": "Ne plus afficher",
            "es": "No anunciar más",
            "pl": "Nie pokazuj więcej",
            "se": "Visa inte igen"
        },
        "Message from the Yes No Game": {
        },
        "Update available": {
        },
        "Yes": {
        },
        "Skip": {
        },
        "OK": {},
        "Confirm": {
        },
        "Cancel": {
        },
        "You don't have enough flags": {
            "de": "Du hast nicht genug Flaggen",
            "at": "Du hast nicht genug Flaggen",
            "fr": "Tu n’as pas assez de drapeaux",
            "es": "No tienes banderas suficientes",
            "pl": "Nie masz wystarczającej ilości flag",
            "se": "Du har inte tillräckligt många flaggor"
        },
        "To get flags:": {
            "de": "Um Flaggen zu gewinnen:",
            "at": "Um Flaggen zu gewinnen:",
            "fr": "Pour gagner des drapeaux:",
            "es": "Para ganar banderas:",
            "pl": "Aby zdobyć flagi",
            "se": "För att vinna flaggor:"
        },
        " - Register with <span class='fa fa-facebook-square'></span> = 50 flags": {
            "de": " - Melde dich mit <span class='fa fa-facebook-square'></span> an = 50",
            "at": " - Melde dich mit <span class='fa fa-facebook-square'></span> an = 50",
            "fr": " - Ouvre ton compte avec <span class='fa fa-facebook-square'></span> = 50",
            "es": " - Anúnciate con <span class='fa fa-facebook-square'></span> = 50",
            "pl": " - Zarejestruj się z <span class='fa fa-facebook-square'></span> = 50",
            "se": " - Registrera dig med <span class='fa fa-facebook-square'></span> = 50"
        },
        " - Invite a friend on <span class='fa fa-facebook-square'></span> = 5 flags": {
            "de": " - Lade einen Freund bei <span class='fa fa-facebook-square'></span> ein = 5",
            "at": " - Lade einen Freund bei <span class='fa fa-facebook-square'></span> ein = 5",
            "fr": " - Invite un ami sur <span class='fa fa-facebook-square'></span> = 5",
            "es": " - Invita a un amigo en <span class='fa fa-facebook-square'></span> = 5",
            "pl": " - Zaproś znajomych na <span class='fa fa-facebook-square'></span> = 5",
            "se": " - Bjud in en vän på <span class='fa fa-facebook-square'></span> = 5"
        },
        " - Play 1 game = 1 flag": {
            "de": " - Ein Spiel gespielt = 1",
            "at": " - Ein Spiel gespielt = 1",
            "fr": " - Fais 1 jeu = 1",
            "es": " - Haz un juego = 1",
            "pl": " - Jedna gra = 1",
            "se": " - Spela 1 spel = 1"
        },
        " - Play 3 times in 1 day = 1 flag": {
            "de": " - Dreimal am Tag gespielt = 1",
            "at": " - Dreimal am Tag gespielt = 1",
            "fr": " - Fais 3 jeux par jour = 1",
            "es": " - Juega 3 veces al día = 1",
            "pl": " - Zagraj 3 razy w ciągu dnia = 1",
            "se": " - Spela 3 gånger på en dag = 1"
        },
        " - Win a Bonus star <span class='fa fa-star'></span> = 2 flags": {
            "de": " - Einen Bonusstern gewinnen <span class='fa fa-star'></span> = 2",
            "at": " - Einen Bonusstern gewinnen <span class='fa fa-star'></span> = 2",
            "fr": " - Gagne une étoile Bonus <span class='fa fa-star'></span> = 2",
            "es": " - Gana una estrella Bonus <span class='fa fa-star'></span> = 2",
            "pl": " - Wygraj bonusową gwiazdkę <span class='fa fa-star'></span> = 2",
            "se": " - Vinn en bonusstjärna <span class='fa fa-star'></span> = 2"
        },
        "Unlock category": {
        },
        "Do you want to use ": {
            "de": "Willst du ",
            "at": "Willst du ",
            "fr": "Tu veux utiliser ",
            "es": "¿Quieres utilizar ",
            "pl": "Czy chcesz użyć ",
            "se": "Vill du använda "
        },
        " flags to unlock this category?": {
            "de": " Flaggen verwenden, um diese Kategorie freizuschalten?",
            "at": " Flaggen verwenden, um diese Kategorie freizuschalten?",
            "fr": " drapeaux pour débloquer cette catégorie?",
            "es": " banderas para desbloquear esta categoría?",
            "pl": " flag aby odblokować następną kategorię?",
            "se": " flaggor för att låsa upp kategorin?"
        },
        "You are offline": {
        },
        "You must be online to unlock a category with flags": {
        },
        "This category is locked": {
            "de": "Kategorie nicht freigeschaltet",
            "at": "Kategorie nicht freigeschaltet",
            "fr": "Catégorie non débloquée",
            "es": "Categoría bloqueada",
            "pl": "Kategoria zablokowana",
            "se": "Kategorin är låst"
        },
        "This category is still locked. Choose a dark blue category at the top of the page.": {
            "de": "Diese Kategorie ist noch nicht freigeschaltet. Wähle eine der oberen dunkelblauen Kategorien aus.",
            "at": "Diese Kategorie ist noch nicht freigeschaltet. Wähle eine der oberen dunkelblauen Kategorien aus.",
            "fr": "Cette catégorie n’est pas encore débloquée. Choisis une catégorie bleu foncé en haut de l’écran.",
            "es": "Esta categoría está aún bloqueada. Elige una categoría azul oscuro en la parte superior de la página.",
            "pl": "Ta kategoria nie została jeszcze odblokowana. Wybierz kategorię ciemnoniebieską na górze ekranu",
            "se": "Den här kategorin är fortfarande låst. Välj en mörkblå kategori högst upp på sidan."
        },
        "The game isn’t over": {
            "de": "Das Spiel ist noch nicht vorbei",
            "at": "Das Spiel ist noch nicht vorbei",
            "fr": "La partie n’est pas terminée",
            "es": "La jugada no está terminada",
            "pl": "Gra nie została ukończona",
            "se": "Spelet är inte slut"
        },
        "If you quit now, you will lose your points.": {
            "de": "Wenn du jetzt aufhörst, verlierst du deine Punkte.",
            "at": "Wenn du jetzt aufhörst, verlierst du deine Punkte.",
            "fr": "Si tu quittes maintenant tu perdras tes points.",
            "es": "Si paras ahora pierdes tus puntos.",
            "pl": "Jeśli wyjdziesz teraz, stracisz punkty.",
            "se": "Om du avslutar nu förlorar du dina poäng."
        },
        "Play ": {
            "de": "Spielen",
            "at": "Spielen",
            "fr": "Jouer",
            "es": "Jugar",
            "pl": "Graj",
            "se": "Spela"
        },
        "Quit": {
            "de": "Aufhören",
            "at": "Aufhören",
            "fr": "Quitter",
            "es": "Parar",
            "pl": "Wyjdź",
            "se": "Avsluta"
        },
        "If you score the same number of points as the category goal, you unlock the next category.": {
            "de": "Wenn du die erforderliche Punktzahl des „Goals“ (Ziels) dieser Kategorie erreichst, schaltest du die nächste Kategorie frei.",
            "at": "Wenn du die erforderliche Punktzahl des „Goals“ (Ziels) dieser Kategorie erreichst, schaltest du die nächste Kategorie frei.",
            "fr": "Si tu marques le nombre de points du « Goal » (objectif) de cette catégorie, tu débloques la catégorie suivante.",
            "es": "Si marcas el número de puntos del “Goal” (objetivo) de esta categoría, desbloquearás la siguiente categoría.",
            "pl": "Jeśli uzyskasz maksymalną liczbę punktów przewidzianą dla tej kategorii (Goal), odblokujesz kolejną kategorię",
            "se": "Om du får lika många poäng som kategorins “Goal” (mål) så kan du låsa upp nästa kategori."
        },
        "The more you play, the more you win flags to unlock new categories. If you score the same number of points as the category goal, you unlock the next category.": {
            "de": "Je öfter du spielt, desto mehr Flaggen zum Freischalten der Kategorien kannst du gewinnen.",
            "at": "Je öfter du spielt, desto mehr Flaggen zum Freischalten der Kategorien kannst du gewinnen.",
            "fr": "Plus tu joues et plus tu gagnes des drapeaux pour débloquer des catégories.",
            "es": "Cuanto más juegues más banderas ganarás para desbloquear categorías.",
            "pl": "Im więcej grasz, tym więcej wygrywasz flag,aby odblokować nowe kategorie",
            "se": "Ju mer du spelar, desto fler flaggor som låser upp nya kategorier vinner du."
        },
        // Categories
        "Click to unlock with flags": {
        },

        // Game
        "time": {
        },
        "bonus": {
        },
        "points": {
        },
        "lives": {
        },
        "YES": {
        },
        "NO": {
        },
        "Goal: ": {
        },
        " points": {
        },
        "Go!": {
        },
        "Well done!": {
        },
        "You've unlocked": {
        },
        "the next category!": {
        },
        "Too bad! ": {
        },
        // " points": {
        // },
        "missing to unlock next": {
        },
        "next category. Try again!": {
        },
        "Sorry! You've": {
        },
        " lost your 3 lives.": {
        },
        "Start again!": {
        },
        "Super! ": {
        },
        " over the goal!": {
        },
        " under the goal!": {
        },
        "Replay": {
        },
        "New game": {
        },
        "Share with friends": {
        },
        // Score and renking
        "Total points": {
        },
        "Top score": {
        },
        "Top correct": {
        },
        "Performance Index": {
        },
        "Categories": {
        },
        "Flags": {
        },
        "Ranking": {
        },
        "Global": {
        },

        // User
        "Register with Facebook": {
        },
        "Win 50 flags": {
        },
        "by using your Facebook account": {
        },
        "Register": {
        },
        "Login": {
        },
        "Identification with email address": {
        },
        "Please enter your email address": {
        },
        "Email address": {
        },
        "Password": {
        },
        "Forgot your password?": {
        },
        "Registration with email address": {
        },
        "Help your friends to find you": {
        },
        "User name": {
        },
        "Birthday": {
        },
        "Link Facebook account to email": {
        },
        "Link": {
        },
        "Send": {
        },
        "Restore your password": {
        },
        "Please enter the code that you received": {
        },
        "Restore password": {
        },
        "My account": {
        },
        "New password": {
        },
        "Save and close": {
        },
        "Logout": {
        },
        "Connect to the internet first": {
        },
        "Your password must have at least 4 characters": {
        },
        "Invite": {
        },
        "Please enter your friends′ email addresses": {
        },
        "Register with email": {
        },
        "No thanks": {
        },
        "Play the Yes No Game with me!": {
            "de": "Spiel Yes No Game mit mir!",
            "at": "Spiel Yes No Game mit mir!",
            "fr": "Viens jouer au Yes No Game avec moi",
            "es": "Ven a jugar al Yes No Game conmigo",
            "pl": "Zagraj ze mną w Yes No Game!",
            "se": "Spela Yes No Game med mig!"
        },
        "Report a problem": {
            "de": "Ein Problem melden",
            "at": "Ein Problem melden",
            "fr": "Signaler un problème",
            "es": "Avisar si hay un problema",
            "pl": "Zgłoś problem",
            "se": "Rapportera ett problem"
        },
        "Message": {
        },

        // Error messages
        "Please enter username": {
        },
        "Please enter password": {
        },
        "Email already exists": {
        },
        "Your username must have at least 4 characters": {
        },
        "Password is incorrect": {
        },
        "The Yes No Game is currently unavailable, please try later.": {
        },


        // Registration
        "As soon as you open your account:": {
            "de": "Sobald du einen Account einrichtet:",
            "at": "Sobald du einen Account einrichtet:",
            "fr": "Dès que tu ouvres ton compte:",
            "es": "Al abrir tu cuenta:",
            "pl": "Po utworzeniu konta:",
            "se": "När du skapar ditt konto så:"
        },
        "The game adapts to your level": {
            "de": "Passt sich das Spiel deinem Niveau an",
            "at": "Passt sich das Spiel deinem Niveau an",
            "fr": "Le jeu s’adapte à ton niveau",
            "es": "El juego se adapta a tu nivel",
            "pl": "Gra dostosowuje się do Twojego poziomu",
            "se": "Anpassas spelet till din nivå"
        },
        "You accumulate your points": {
            "de": "Sammelst du Punkte",
            "at": "Sammelst du Punkte",
            "fr": "Tu cumules tes points",
            "es": "Acumulas puntos",
            "pl": "Zbierasz punkty",
            "se": "Sammanställs dina poäng"
        },
        "You save your categories": {
            "de": "Kannst du deine Kategorien speichern",
            "at": "Kannst du deine Kategorien speichern",
            "fr": "Tu sauvegardes tes catégories",
            "es": "Registras tus categorías",
            "pl": "Zapisujesz swoje kategorie",
            "se": "Sparas dina kategorier"
        },
        "You access all the rankings": {
            "de": "Hast du Zugriff auf alle Ranglisten",
            "at": "Hast du Zugriff auf alle Ranglisten",
            "fr": "Tu accèdes à tous les classements",
            "es": "Accedes a las clasificaciones",
            "pl": "Masz dostęp do wszystkich rankingów",
            "se": "Får du tillgång till alla rankingar"
        },
        "Play with your friends": {
            "de": "Spiele mit deinen Freunden",
            "at": "Spiele mit deinen Freunden",
            "fr": "Joue avec tes amis",
            "es": "Juega con tus amigos",
            "pl": "Zagraj ze znajomymi",
            "se": "Spela med dina vänner"
        },
    }

    appLanguage = "en";
    global.appLanguage = appLanguage;

    availableLanguages.forEach(function(language){
        if(navLanguage.indexOf(language) !== -1) {
            appLanguage = language;
            global.appLanguage = language;
        }
    });


    function _(message){
        if(!appLanguage || !messages[message] || !messages[message][appLanguage]) {
            return message;
        } else {
            return messages[message][appLanguage];
        }
    }

    global._ = _;
})(window);
