(function(global){

    var currentUser;

    function registerDevice(user){
        currentUser = user;
        if(device.platform == 'android'
            || device.platform == 'Android'
            || device.platform == "amazon-fireos"){

            pushNotification.register(
                function(){
                    console.log("Register device success:");
                    console.log(arguments);
                },
                function(){
                    console.log("Register device error:");
                    console.log(arguments);
                },
                {
                    "senderID": settings.senderID,
                    "ecb":"onNotification"
                }
            );
        } else {
            pushNotification.register(
                function(deviceToken){
                    quizAPI.callURL("registerUserDevice", {
                        userID: currentUser.userID,
                        uid: deviceToken,
                        appVersion: window.AppVersion,
                        deviceType: "ios"
                    }, function(){
                        console.log(arguments)
                    });

                    console.log("Register device success:");
                    console.log(arguments);
                },
                function(){
                    console.log("Register device error:");
                    console.log(arguments);
                },
                {
                    "badge":"true",
                    "sound":"true",
                    "alert":"true",
                    "ecb":"onNotificationAPN"
                }
            );
        }
    }

    global.onNotification = function(e){ // Android
        switch(e.event){
            case 'registered':
                if(e.regid.length>0){
                    console.log(e.regid);
                    quizAPI.callURL("registerUserDevice", {
                        userID: currentUser.userID,
                        uid: e.regid,
                        appVersion: window.AppVersion,
                        deviceType: "android"
                    }, function(){
                        console.log(arguments)
                    })
                }
                // Your GCM push server needs to know the regID before it can push to this device
                // here is where you might want to send it the regID for later use.
                break;

            case 'message':
                // if this flag is set, this notification happened while we were in the foreground.
                // you might want to play a sound to get the user's attention, throw up a dialog, etc.
                if(app.appBody.hasClass("playing")) {
                    app.game.onEnd = function(){
                        dialog(_("Message from Yes No Game"), e.payload.message, [
                            {
                                value: _("OK")
                            }
                        ]);
                    }
                    // show message on game end
                } else {
                    dialog(_("Message from Yes No Game"), e.payload.message, [
                        {
                            value: _("OK")
                        }
                    ]);
                }
                break;

            case 'error':
                dialog(_("Error"), e.msg, [
                    {
                        value: _("OK")
                    }
                ]);
                break;
        }
    }

    global.onNotificationAPN = function(event) {
        if(event.alert){
            if(app.appBody.hasClass("playing")) {
                app.game.onEnd = function(){
                    dialog(_("Message from Yes No Game"), event.alert, [
                        {
                            value: _("OK")
                        }
                    ]);
                    var snd = new Media("/sounds/notify.wav");
                    snd.play();
                }
                // show message on game end
            } else {
                dialog(_("Message from Yes No Game"), event.alert, [
                    {
                        value: _("OK")
                    }
                ]);
                var snd = new Media("/sounds/notify.wav");
                snd.play();
            }
        }


        // if(event.badge){
        if(!event.foreground){
            pushNotification.setApplicationIconBadgeNumber(
                function(result){ console.log(result) },
                function(){ console.log(arguments) },
                1
            );
        }
    }

    global.registerDevice = registerDevice;

})(window);