(function(global){

    function getMonthName(delta){
        var delta = delta || 0,
            months = ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"],
            curMonth = (new Date()).getMonth();

        curMonth = curMonth - delta;
        if(curMonth < 0) { curMonth += 12 }
        return _(months[curMonth]);
    }

    function ScoreViews(){}

    ScoreViews.prototype = {
        renderScorePage: function(){
            app.addPage(function(){
                app.renderScorePage();
            });

            var that = this,
                user = app.user.user,
                categories = app.categories.map(function(c){ return c.categoryID }),
                categoriesUnlocked = app.categoriesUnlocked.filter(function(cu){
                    return categories.indexOf(cu) !== -1;
                });

            this.appBody.innerHTML = "";

            var page = dom(".page.score-page", {}, [
                dom("header", [
                    this.renderLogo(),
                    dom(".the-first-contest-wrapper", [
                        dom(".the-first-contest")
                    ])
                ]),
                dom(".content", [
                    dom(".score-table-wrapper", [
                        dom("table", [
                            dom("tr", [
                                dom("td", [
                                    dom("span", _("Total points"))
                                ]),
                                dom("td", app.user.getTotalPoints()),
                                dom("td", app.user.getTotalPointsPercent()+"%")
                            ]),
                            dom("tr", [
                                dom("td", [
                                    dom("span", _("Top score"))
                                ]),
                                dom("td", app.user.getTopPoints()),
                                dom("td", app.user.getTopPointsPercent()+"%")
                            ]),
                            dom("tr", [
                                dom("td", [
                                    dom("span", _("Top correct"))
                                ]),
                                dom("td", app.user.getCorrectAnswers()),
                                dom("td", app.user.getCorrectAnswersPercent()+"%")
                            ]),
                            dom("tr", [
                                dom("td.empty", {colspan: 3})
                            ]),
                            dom("tr", [
                                dom("td", [
                                    dom("span", _("Performance Index"))
                                ]),
                                dom("td", "-"),
                                dom("td", app.user.getGeneralScore()+"/100")
                            ]),
                            dom("tr", [
                                dom("td.empty", {colspan: 3})
                            ]),
                            dom("tr", [
                                dom("td", [
                                    dom("span", _("Categories"))
                                ]),
                                dom("td", "-"),
                                dom("td", categoriesUnlocked.length + "/" + categories.length),
                            ]),
                            dom("tr", [
                                dom("td", [
                                    dom("span", _("Flags") + " <span class='usa-flag'></span><span class='usa-flag'></span>")
                                ]),
                                dom("td", "-"),
                                dom("td", app.user.getFlags()),
                            ]),
                            dom("tr", [
                                dom("td.ranking-td", {colspan: "3"}, [
                                    this.rankingButton = dom("span.ranking", _("Ranking"))
                                ])
                            ])
                        ])
                    ])
                ])
            ]);

            if(!app.onLine) {
                this.rankingButton.addClass("hidden");
            }

            if(app.isAnonymousUser()) {
                this.rankingButton.addEventListener("click", app.user.renderJoinPage.bind(this));
            } else {
                this.rankingButton.addEventListener("click", this.showRankingPage.bind(this));
            }

            this.appBody.appendChild(page);


            if(!app.doNotTrackHistory) {
                window.history.pushState({
                    page: "renderScorePage"
                }, "Yes No Game");
            } else {
                app.doNotTrackHistory = false;
            }
        },
        renderRankingPage: function(pointScope, userScope, timeScope){
            var firstPage = !pointScope,
                pointScope = pointScope || "points",
                userScope = userScope || "global",
                timeScope = timeScope || "last1000",
                user = app.user.user, avatar,
                that = this;

            if(firstPage) {
                app.addPage(function(){
                    app.renderRankingPage(field, userScope);
                });
            }

            var fieldSettings = ["points", "categories"],
                timeSettings = {
                    'last1000': { title: _("Last 300 games"), next: "curMonth" },
                    'curMonth': { title: getMonthName(0), next: "prevMonth" },
                    'prevMonth': { title: getMonthName(1), next: "prevPrevMonth" },
                    'prevPrevMonth': { title: getMonthName(2), next: "last1000" }
                }

            this.appBody.innerHTML = "";

            var page = dom(".page.ranking-page", {}, [
                this.pageHeader = dom("header", [
                    this.renderLogo(),
                    dom(".the-first-contest-wrapper", [
                        dom(".the-first-contest")
                    ])
                ]),
                this.contentElement = dom(".content", [
                    this.rankingHeader = dom(".ranking-header", [
                        this.pointsScoreButton = dom(".button.points-score", _("Points")),
                        this.categoriesScoreButton = dom(".button.categories-score", _("Categories")),
                        this.nextButton = dom("span.ranking-title", [
                            dom("span", timeSettings[timeScope].title),
                            dom("span.ranking-next" + (pointScope==="points"?".arrow":""))
                        ])
                    ]),
                    this.scopeButtons = dom(".scope-buttons")
                ])
            ]);

            this.globalScopeButton = dom(".button.global-scope", _("Global"));
            this.countryScopeButton = dom(".button.country-scope", [
                this.countryLabel = dom(".country-label", app.user.user.country)
            ]);
            this.facebookScopeButton = dom(".button.facebook-scope", "FACEBOOK");

            this.scopeButtons.appendChild(this.globalScopeButton);
            this.scopeButtons.appendChild(this.countryScopeButton);

            if(app.isSchoolRankingEnabled()) {
                if(app.user.user.country.length >=13) {
                    this.countryLabel.addClass("super-small");
                } else if(app.user.user.country.length >=10){
                    this.countryLabel.addClass("small");
                }

                this.schoolScopeButton = dom(".button.school-scope", _("My school"));
                this.scopeButtons.appendChild(this.schoolScopeButton);

            } else {
                this.scopeButtons.addClass("without-school");
            }

            this.scopeButtons.appendChild(this.facebookScopeButton);

            if(userScope === "friends" && !user.facebookId) {
                this.contentElement.appendChild(
                    dom(".features-descriptions", [
                        dom(".feature", _("Play with your friends")),
                        dom(".feature", _("You access all the rankings"))
                    ])
                );

                this.contentElement.appendChild(
                    dom(".friends-join-facebook-wrapper", [
                        this.playOnFacebookButton = dom(".play-on-facebook-container", [
                            dom(".play-on-facebook-header", {}, [
                                dom("span", _("Register with Facebook")),
                                dom("span.fa.fa-facebook-square")
                            ]),
                            dom(".play-on-facebook-footer", {}, [
                                dom("span", _("Win 50 flags")),
                                dom(".go.arrow.blue")
                            ])
                        ])
                    ])
                );

                this.playOnFacebookButton.addEventListener("click", function(){
                    app.user.signInWithFacebook(app.renderMenuPage.bind(app));
                });
            } else if(userScope === "school" && !user.schoolId) {
                this.contentElement.appendChild(
                    dom(".form-wrapper", [
                        dom("form", [
                            dom("header", _("Select school")),
                            this.formFields = dom(".fields", [
                                this.errorsArea = dom(".errors")
                            ]),
                            dom(".buttons", [
                                this.saveSchool = dom(".button", _("Save school")),
                            ])
                        ])
                    ])
                );

                app.user.renderSchoolSelector(this.formFields);

                this.saveSchool.addEventListener("click", function(){
                    app.user.saveSchool(function(){
                        app.user.loadRanking(pointScope, userScope, timeScope, function(){
                            app.renderRankingPage(pointScope, userScope, timeScope);
                        });
                    });
                });
            } else {
                if(timeScope !== "last1000" || userScope == "school" || user[pointScope][timeScope][userScope].uData.position <= 300){
                    this.contentElement.appendChild(
                        this.myRankingContainer = dom(".my-ranking", [
                            dom(".ranking-table-wrapper", [
                                dom("table", [
                                    dom("tr", [
                                        dom("td", [
                                            avatar = dom("img", { src: "design/user_picture.jpg" })
                                        ]),
                                        dom("td", [
                                            dom(".user-position-and-name",
                                                user[pointScope][timeScope][userScope].uData.position + ". " + user.username
                                            )
                                        ]),
                                        dom("td", user[pointScope][timeScope][userScope].uData.points),
                                        dom("td", [
                                            this.myFlagElement = dom("span.flag")
                                        ])
                                    ])
                                ])
                            ])
                        ])
                    );
                    if(user.countryCode) {
                        this.myFlagElement.addClass(user.countryCode.toLowerCase());
                    }
                }

                var prevUserPoints = -1;

                this.contentElement.appendChild(
                    this.userRankingContainer = dom(".users-ranking", [
                        dom(".ranking-table-wrapper", [
                            dom("table", (user[pointScope][timeScope][userScope].scorePoints||[]).map(function(currentUser){
                                var row, avatar, flagElement;

                                if(currentUser.points == prevUserPoints) {
                                    currentUser.position = prevUserPosition;
                                }
                                prevUserPosition = currentUser.position;
                                prevUserPoints = currentUser.points;

                                row = dom("tr", [
                                    dom("td", [
                                        avatar = dom("img", { src: "design/user_picture.jpg" })
                                    ]),
                                    dom("td", [
                                        dom(".user-position-and-name", [
                                            dom("span.position", currentUser.position + ". "),
                                            dom("span", currentUser.name)
                                        ])
                                    ]),
                                    dom("td", currentUser.points),
                                    dom("td", [
                                        flagElement = dom("span.flag")
                                    ])
                                ]);

                                if(currentUser.countryCode) {
                                    flagElement.addClass(currentUser.countryCode.toLowerCase());
                                }

                                if(currentUser.facebookId) {
                                    avatar.src = "https://graph.facebook.com/" + currentUser.facebookId + "/picture";
                                }

                                return row;
                            }))
                        ])
                    ])
                );

                if(userScope=="school") {
                    this.myRankingContainer.appendChild(
                        dom(".school-name", app.user.user.schoolName)
                    );
                }

                if((userScope=="friends" || userScope=="school") && (user[pointScope][timeScope][userScope].scorePoints||[]).length<20){
                    this.contentElement.appendChild(
                        this.inviteButtonWrapper = dom(".invite-button-wrapper", [
                            this.inviteButton = dom(".button.invite-button", _("Invite friends"))
                        ])
                    );

                    this.inviteButton.addEventListener("click", function(){
                        if(window.cordova && !app.signedInWithFacebook) {
                            FB.login(['email', 'user_birthday', 'user_friends'], function(){
                                app.signedInWithFacebook = true;
                                app.user.inviteFacebookFriends();
                            });
                        } else {
                            app.user.inviteFacebookFriends();
                        }
                    });
                }

                if((user[pointScope][timeScope][userScope].scorePoints||[]).length>0){
                    setTimeout(function(){
                        var height = parseInt($(window).height())
                                     - parseInt($(that.pageHeader).height())
                                     - parseInt($(that.rankingHeader).height())
                                     - parseInt($(that.scopeButtons).height())
                                     - parseInt($(that.myRankingContainer).height());

                        if((userScope=="friends" || userScope=="school")
                            && user[pointScope][timeScope][userScope].scorePoints.length<20) {

                            height = height - parseInt($(that.inviteButtonWrapper).height());
                        }

                        $(that.userRankingContainer).css("max-height", height + "px");
                    }, 10)
                }
            }

            if(user.facebookId && avatar) {
                avatar.src = "https://graph.facebook.com/" + user.facebookId + "/picture";
            }

            this.appBody.appendChild(page);

            if(firstPage) {
                if(!app.doNotTrackHistory) {
                    window.history.pushState({
                        page: "renderRankingPage"
                    }, "Yes No Game");
                } else {
                    app.doNotTrackHistory = false;
                }
            }

            if(userScope === "global") this.globalScopeButton.addClass("active");
            if(userScope === "country") this.countryScopeButton.addClass("active");
            if(userScope === "school") this.schoolScopeButton.addClass("active");
            if(userScope === "friends") this.facebookScopeButton.addClass("active");

            if(pointScope === "points") this.pointsScoreButton.addClass("active");
            if(pointScope === "categories") this.categoriesScoreButton.addClass("active");


            if(pointScope==="points") {
                this.nextButton.addEventListener("click", function(){
                    app.user.loadRanking("points", userScope, timeSettings[timeScope].next, function(){
                        app.renderRankingPage("points", userScope, timeSettings[timeScope].next);
                    });
                });
            }

            this.globalScopeButton.addEventListener("click", function(){
                app.renderRankingPage(pointScope, "global", timeScope);
            });

            this.countryScopeButton.addEventListener("click", function(){
                app.renderRankingPage(pointScope, "country", timeScope);
            });

            this.schoolScopeButton && this.schoolScopeButton.addEventListener("click", function(){
                app.renderRankingPage(pointScope, "school", timeScope);
            });

            this.facebookScopeButton.addEventListener("click", function(){
                app.renderRankingPage(pointScope, "friends", timeScope);
            });

            this.pointsScoreButton.addEventListener("click", function(){
                app.user.loadRanking("points", userScope, timeScope, function(){
                    app.renderRankingPage("points", userScope, timeScope);
                });
            });

            this.categoriesScoreButton.addEventListener("click", function(){
                app.user.loadRanking("categories", userScope, timeScope, function(){
                    app.renderRankingPage("categories", userScope, "last1000");
                });
            });
        }
    }

    window.ScoreViews = ScoreViews;
})(window);