(function(global){

    function Tests(){}

    Tests.prototype = {
        isDesktop: function(){
            return !navigator.userAgent.match(/(iPad)|(iPhone)|(iPod)|(android)|(webOS)/i);
        },
        isWebkit: function(){
            return /WebKit/.test(navigator.userAgent);
        },
        isAndroid: function(){
            var ua = navigator.userAgent.toLowerCase();
            return ua.indexOf("android") > -1;
        },
        isAndroid4: function(){
            var androidVersion = parseFloat(navigator.userAgent.match(/Android\s+([\d\.]+)/)[1]);

            return androidVersion >= 4.0;
        },
        isAndroid4_4: function(){
            var androidVersion = parseFloat(navigator.userAgent.match(/Android\s+([\d\.]+)/)[1]);

            return androidVersion >= 4.4;
        },
        isIOS: function(){
            return !!navigator.userAgent.match(/(iPod|iPhone|iPad)/);
        },
        isIOS6: function(){
            var ua = navigator.userAgent,
                osIndex = ua.indexOf("OS ");

            return parseFloat(ua.substr(osIndex+3, 3).replace("_", ".")) >= 6.0;
        },
        isIE: function(){
            var ua = window.navigator.userAgent;
            var msie = ua.indexOf('MSIE ');
            var trident = ua.indexOf('Trident/');

            if (msie > 0) {
                // IE 10 or older => return version number
                return parseInt(ua.substring(msie + 5, ua.indexOf('.', msie)), 10);
            }

            if (trident > 0) {
                // IE 11 (or newer) => return version number
                var rv = ua.indexOf('rv:');
                return parseInt(ua.substring(rv + 3, ua.indexOf('.', rv)), 10);
            }

            // other browser
            return false;
        },
        isIE10: function(){
            return !!window.atob;
        },
        isCompatible: function(){
            if(this.isAndroid()) {
                return this.isAndroid4();
            }

            if(this.isIE()) {
                return this.isIE10();
            }

            if(this.isIOS()) {
                return this.isIOS6();
            }

            return true;
        },
        isFF: function(){
            return navigator.userAgent.toLowerCase().indexOf('firefox') > -1;
        },
        startSyncCategoriesCount: function(){
            if(this.isIOS()) {
                return 10;
            }

            if(this.isIE()) {
                return 10;
            }

            if(this.isAndroid() && !this.isAndroid4_4()) {
                return 10;
            }

            return 15;
        }
    }

    window.Tests = Tests;
})(window);