(function(global){
    'use strict';

    // Mixin with page layouts
    function UserScore(){}

    UserScore.prototype = {
        getTotalPoints: function(){
            var points = this.user.pointsTotal,
                notSavedGames;

            if(localStorage.games) {
                notSavedGames = JSON.parse(localStorage.games);
                notSavedGames.forEach(function(game){
                    if(game.userId === app.getUserID()) {
                        points += game.points;
                    }
                })
            }

            return points||0;
        },
        getTotalPointsPercent: function(){
            return this.user.pointsTotalPercent||0;
        },
        getTopPoints: function(){
            var points = this.user.pointsMax,
                notSavedGames;

            if(localStorage.games) {
                notSavedGames = JSON.parse(localStorage.games);
                notSavedGames.forEach(function(game){
                    if(game.userId === app.getUserID()) {
                        if(game.points > points) {
                            points = game.points;
                        }
                    }
                })
            }

            return points||0;
        },
        getTopPointsPercent: function(){
            return this.user.pointsMaxPercent||0;
        },
        getAveragePoints: function(){
            // TODO: calculate
            return this.user.pointsAverage;
        },
        getAveragePointsPercent: function(){
            return this.user.pointsAveragePercent||0;
        },
        getTotalFlags: function(){
            var flags = this.user.flagsTotal,
                notSavedGames;

            if(localStorage.games) {
                notSavedGames = JSON.parse(localStorage.games);
                notSavedGames.forEach(function(game){
                    if(game.userId === app.getUserID()) {
                        flags += game.flags;
                    }
                })
            }

            return flags||0;
        },
        getFlags: function(){
            var flags = this.user.flags,
                notSavedGames;

            if(localStorage.games) {
                notSavedGames = JSON.parse(localStorage.games);
                notSavedGames.forEach(function(game){
                    if(game.userId === app.getUserID()) {
                        flags += game.flags;
                    }
                })
            }

            return flags||0;
        },
        getCorrectAnswers: function(){
            var points = this.user.correctAnswers||0,
                notSavedGames;

            if(localStorage.games) {
                notSavedGames = JSON.parse(localStorage.games);
                notSavedGames.forEach(function(game){
                    if(game.userId === app.getUserID()) {
                        if(game.correctAnswers > points) {
                            points = game.correctAnswers;
                        }
                    }
                })
            }

            return points||0;
        },
        getCorrectAnswersPercent: function(){
            return this.user.correctAnswersPercent||0;
        },
        getGeneralScore: function(){
            return this.user.generalScore||0;
        }
    }

    window.UserScore = UserScore;
})(window);